-module(kv_vnode_sup).

-behaviour(supervisor).

-export([start_link/0, start_vnode/1]).

%%% supervisor callbacks
-export([init/1]).

%%% public api

start_link() ->
    supervisor:start_link({local, ?MODULE}, ?MODULE, []).

-spec start_vnode(Index :: non_neg_integer()) -> supervisor:startchild_ret().
start_vnode(Index) ->
    supervisor:start_child(?MODULE, [Index]).

%%% supervisor callbacks

init([]) ->
    SupFlags = #{
        strategy => simple_one_for_one,
        intensity => 0,
        period => 1
    },
    ChildSpec = #{
        id => undefined,
        start => {kv_vnode, start_link, []},
        restart => temporary,
        type => worker
    },
    {ok, {SupFlags, [ChildSpec]}}.

%%% internal functions
